## timew 1.0.0~beta1+ds

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
set (CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set (HAVE_CMAKE true)

project (timew)
include (CXXSniffer)

set (PROJECT_VERSION "1.0.0.beta1")

message ("-- Looking for SHA1 references")
if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
  set (HAVE_COMMIT true)
  execute_process (COMMAND git log -1 --pretty=format:%h
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                   OUTPUT_VARIABLE COMMIT)
  configure_file ( ${CMAKE_SOURCE_DIR}/commit.h.in
                   ${CMAKE_SOURCE_DIR}/commit.h)
  message ("-- Found SHA1 reference: ${COMMIT}")
endif (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@taskwarrior.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")

if (FREEBSD)
SET (TIMEW_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TIMEW_MAN5DIR man/man5 CACHE STRING "Installation directory for man pages, section 5")
else (FREEBSD)
SET (TIMEW_MAN1DIR share/man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TIMEW_MAN5DIR share/man/man5 CACHE STRING "Installation directory for man pages, section 5")
endif (FREEBSD)
SET (TIMEW_DOCDIR  share/doc/timew CACHE STRING "Installation directory for doc files")

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
add_subdirectory (src/commands)
add_subdirectory (doc)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

set (doc_FILES NEWS ChangeLog README.md INSTALL AUTHORS COPYING LICENSE)
foreach (doc_FILE ${doc_FILES})
  install (FILES ${doc_FILE}  DESTINATION ${TIMEW_DOCDIR})
endforeach (doc_FILE)

# ---

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache" "CMakeFiles" "CPackConfig" "CPackSourceConfig"
                                "_CPack_Packages" "cmake_install" "install_manifest" "Makefile$"
                                "test" "package-config" "src/timew$" "src/libtimew.a"
                                "src/commands/libcommands.a" "src/lex$" "src/liblibshared.a"
                                "/\\\\.gitignore" "/\\\\.git/" "swp$")
include (CPack)

=== doc/holidays/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring holiday documentation")

install (FILES README         DESTINATION ${TIMEW_DOCDIR}/doc/holidays)
install (FILES holidays.en-US DESTINATION ${TIMEW_DOCDIR}/doc/holidays)
install (FILES refresh        DESTINATION ${TIMEW_DOCDIR}/doc/holidays)

=== debian/changelog ===
timew (1.0.0~beta1+ds-1) unstable; urgency=medium

  * Initial release (closes: #827819)

 -- Gordon Ball <gordon@chronitis.net>  Wed, 03 Aug 2016 12:02:10 +0100

=== debian/control ===
Source: timew
Section: utils
Priority: extra
Maintainer: Debian Tasktools Packaging Team <pkg-tasktools-discuss@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper (>= 9), cmake, git, python
Standards-Version: 3.9.8
Homepage: https://taskwarrior.org/
Vcs-Browser: https://anonscm.debian.org/git/pkg-tasktools/timew.git
Vcs-Git: https://anonscm.debian.org/git/pkg-tasktools/timew.git

Package: timewarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: taskwarrior
Description: feature-rich time tracking utility
 Timewarrior is a time tracking utility that offers simple stopwatch features
 as well as sophisticated calendar-based backfill, along with flexible
 reporting.

=== debian/watch ===
# this watchfile will find new releases, but currently doesn't download
# them correctly as a git submodule (src/libshared) is also required

version=4
opts="mode=git,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/" \
https://git.tasktools.org/scm/tm/timew.git refs/tags/v([0-9.]+[.alphbet]*[0-9]?)

## timew 1.0.0%2Bds.1

=== src/libshared/test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# See this CMake issue before complaining about the following.
# https://cmake.org/Bug/view.php?id=16062
if(POLICY CMP0037)
  cmake_policy(SET CMP0037 OLD)
endif()

include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/test
                     ${SHARED_INCLUDE_DIRS})

set (test_SRCS args.t autocomplete.t composite.t color.t shared.t configuration.t datetime.t duration.t format.t fs.t json.t json_test json2_test lexer.t list.t msg.t palette.t pig.t rx.t table.t unicode.t utf8.t)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS}
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} shared ${SHARED_LIBRARIES})
endforeach (src_FILE)

configure_file(run_all run_all COPYONLY)
configure_file(problems problems COPYONLY)

## timew 1.0.0+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.0.0.beta1")
+set (PROJECT_VERSION "1.0.0")
 
 message ("-- Looking for SHA1 references")
 if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
@@ -44,6 +44,7 @@
 add_subdirectory (src)
 add_subdirectory (src/commands)
 add_subdirectory (doc)
+add_subdirectory (ext)
 if (EXISTS ${CMAKE_SOURCE_DIR}/test)
   add_subdirectory (test EXCLUDE_FROM_ALL)
 endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring documentation")

add_subdirectory (holidays)
add_subdirectory (themes)

configure_file (man/timew.1.in man/timew.1)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/ DESTINATION ${TIMEW_MAN1DIR} FILES_MATCHING PATTERN "*.1")

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${TIMEW_INCLUDE_DIRS})

set (timew_SRCS CLI.cpp        CLI.h
                Database.cpp   Database.h
                Datafile.cpp   Datafile.h
                Exclusion.cpp  Exclusion.h
                Extensions.cpp Extensions.h
                Interval.cpp   Interval.h
                Range.cpp      Range.h
                Rules.cpp      Rules.h
                data.cpp
                dom.cpp
                init.cpp
                helper.cpp
                log.cpp
                util.cpp
                validate.cpp)

set (libshared_SRCS libshared/src/Args.cpp          libshared/src/Args.h
                    libshared/src/Color.cpp         libshared/src/Color.h
                    libshared/src/Composite.cpp     libshared/src/Composite.h
                    libshared/src/Configuration.cpp libshared/src/Configuration.h
                    libshared/src/Datetime.cpp      libshared/src/Datetime.h
                    libshared/src/Duration.cpp      libshared/src/Duration.h
                    libshared/src/FS.cpp            libshared/src/FS.h
                    libshared/src/JSON.cpp          libshared/src/JSON.h
                    libshared/src/JSON2.cpp         libshared/src/JSON2.h
                    libshared/src/Lexer.cpp         libshared/src/Lexer.h
                    libshared/src/Msg.cpp           libshared/src/Msg.h
                    libshared/src/Palette.cpp       libshared/src/Palette.h
                    libshared/src/Pig.cpp           libshared/src/Pig.h
                    libshared/src/RX.cpp            libshared/src/RX.h
                    libshared/src/Table.cpp         libshared/src/Table.h
                    libshared/src/Timer.cpp         libshared/src/Timer.h
                    libshared/src/format.cpp        libshared/src/format.h
                    libshared/src/shared.cpp        libshared/src/shared.h
                    libshared/src/unicode.cpp       libshared/src/unicode.h
                    libshared/src/utf8.cpp          libshared/src/utf8.h
                    libshared/src/wcwidth6.cpp)

add_library (timew     STATIC ${timew_SRCS})
add_library (libshared STATIC ${libshared_SRCS})
add_executable (timew_executable timew.cpp)
add_executable (lex_executable   lex.cpp)

target_link_libraries (timew_executable timew libshared commands timew libshared ${TIMEW_LIBRARIES})
target_link_libraries (lex_executable   timew libshared                libshared ${TIMEW_LIBRARIES})

set_property (TARGET timew_executable PROPERTY OUTPUT_NAME "timew")
set_property (TARGET lex_executable   PROPERTY OUTPUT_NAME "lex")

install (TARGETS timew_executable DESTINATION bin)

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# See this CMake issue before complaining about the following.
# https://cmake.org/Bug/view.php?id=16062
if(POLICY CMP0037)
  cmake_policy(SET CMP0037 OLD)
endif()

include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${CMAKE_SOURCE_DIR}/test)

include_directories (${CMAKE_INSTALL_PREFIX}/include)
link_directories(${CMAKE_INSTALL_PREFIX}/lib)

set (test_SRCS data.t exclusion.t helper.t interval.t range.t rules.t util.t)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS}
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} timew libshared ${TIMEW_LIBRARIES})
endforeach (src_FILE)

configure_file(run_all run_all COPYONLY)
configure_file(problems problems COPYONLY)

=== doc/themes/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring theme documentation")

install (FILES README     DESTINATION ${TIMEW_DOCDIR}/doc/themes)
install (FILES dark.theme DESTINATION ${TIMEW_DOCDIR}/doc/themes)

=== src/commands/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${TIMEW_INCLUDE_DIRS})

set (commands_SRCS CmdCancel.cpp
                   CmdChart.cpp
                   CmdConfig.cpp
                   CmdContinue.cpp
                   CmdDefault.cpp
                   CmdDelete.cpp
                   CmdDiagnostics.cpp
                   CmdExport.cpp
                   CmdExtensions.cpp
                   CmdFill.cpp
                   CmdGaps.cpp
                   CmdGet.cpp
                   CmdHelp.cpp
                   CmdJoin.cpp
                   CmdLengthen.cpp
                   CmdMove.cpp
                   CmdReport.cpp
                   CmdStart.cpp
                   CmdStop.cpp
                   CmdSummary.cpp
                   CmdShorten.cpp
                   CmdShow.cpp
                   CmdSplit.cpp
                   CmdTag.cpp
                   CmdTags.cpp
                   CmdTrack.cpp
                   CmdUntag.cpp)

add_library (commands STATIC ${commands_SRCS})

=== src/libshared/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
set (CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set (HAVE_CMAKE true)

project (shared)
include (CXXSniffer)

set (PROJECT_VERSION "1.0.0")

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@taskwarrior.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

=== src/libshared/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src)

set (shared_HEADERS Args.h
                    Color.h
                    Composite.h
                    Configuration.h
                    Datetime.h
                    Duration.h
                    FS.h
                    JSON.h
                    JSON2.h
                    Lexer.h
                    Log.h
                    Msg.h
                    Palette.h
                    Pig.h
                    RX.h
                    Table.h
                    Timer.h
                    shared.h
                    format.h
                    unicode.h
                    utf8.h)

set (shared_SRCS Args.cpp
                 Color.cpp
                 Composite.cpp
                 Configuration.cpp
                 Datetime.cpp
                 Duration.cpp
                 FS.cpp
                 JSON.cpp
                 JSON2.cpp
                 Lexer.cpp
                 Log.cpp
                 Msg.cpp
                 Palette.cpp
                 Pig.cpp
                 RX.cpp
                 Table.cpp
                 Timer.cpp
                 shared.cpp
                 format.cpp
                 unicode.cpp
                 utf8.cpp
                 wcwidth6.cpp
                 ${shared_HEADERS})

add_library (shared STATIC ${shared_SRCS})

set (CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries")
install (TARGETS shared DESTINATION lib)
install (FILES ${shared_HEADERS} DESTINATION include)

=== debian/changelog ===
timew (1.0.0+ds.1-3) unstable; urgency=medium

  [ Gordon Ball ]
  * Update python shebang lines from "/usr/bin/env python" to
    "/usr/bin/python", and suggest python (LP: #1663628)
  * Update Standards-Version to 4.1.1 (priority extra -> optional)

  [ Iain R. Learmonth ]
  * Update maintainer team email address

 -- Gordon Ball <gordon@chronitis.net>  Tue, 21 Nov 2017 10:12:52 +0000

timew (1.0.0+ds.1-2) unstable; urgency=medium

  * Update d/watch and d/rules with new git URL
  * Update Standards-Version to 4.0.0
  * Update debhelper compat to 10
  * Use HTTPS URL for copyright format, update years in d/copyright
  * Install the upstream changelog

 -- Gordon Ball <gordon@chronitis.net>  Thu, 06 Jul 2017 21:09:10 +0200

timew (1.0.0+ds.1-1) unstable; urgency=medium

  * Team Upload
  * Version bump to work around dak issues

 -- Iain R. Learmonth <irl@debian.org>  Sat, 03 Sep 2016 12:54:45 +0100

timew (1.0.0+ds-1) unstable; urgency=medium

  * New upstream version: 1.0.0 

 -- Gordon Ball <gordon@chronitis.net>  Mon, 22 Aug 2016 09:16:29 +0200

=== debian/control ===
Source: timew
Section: utils
Priority: optional
Maintainer: Debian Tasktools Packaging Team <taskdeb-discuss@nongnu.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper (>= 10), cmake, git, python
Standards-Version: 4.1.1
Homepage: https://taskwarrior.org/
Vcs-Browser: https://anonscm.debian.org/git/pkg-tasktools/timew.git
Vcs-Git: https://anonscm.debian.org/git/pkg-tasktools/timew.git

Package: timewarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: python
Recommends: taskwarrior
Description: feature-rich time tracking utility
 Timewarrior is a time tracking utility that offers simple stopwatch features
 as well as sophisticated calendar-based backfill, along with flexible
 reporting.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
TAG_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | tr '~' '.' | sed -e 's/+[dfsg]\+//')

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	find . -type f -exec sed -i '1s|^#!/usr/bin/env python|#!/usr/bin/python|' {} \;
	dh_auto_configure

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

get-orig-source:
	@echo downloading git tag v$(TAG_VERSION)
	git clone -b v$(TAG_VERSION) --depth 1 --recursive https://git.tasktools.org/tm/timew.git
	tar -cJ --wildcards --owner=root --group=root --mode=a+rX --exclude '.git*' -f timew_$(DEB_VERSION_UPSTREAM).orig.tar.xz timew/
	rm -rf timew/

=== debian/watch ===
--- 
+++ 
@@ -3,4 +3,4 @@
 
 version=4
 opts="mode=git,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/" \
-https://git.tasktools.org/scm/tm/timew.git refs/tags/v([0-9.]+[.alphbet]*[0-9]?)
+https://git.tasktools.org/tm/timew.git refs/tags/v([0-9.]+[.alphbet]*[0-9]?)

## timew 1.1.0+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.0.0")
+set (PROJECT_VERSION "1.1.0")
 
 message ("-- Looking for SHA1 references")
 if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
@@ -27,13 +27,13 @@
 set (PACKAGE_VERSION "${VERSION}")
 set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
 
-if (FREEBSD)
+if (FREEBSD OR DRAGONFLY)
 SET (TIMEW_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
 SET (TIMEW_MAN5DIR man/man5 CACHE STRING "Installation directory for man pages, section 5")
-else (FREEBSD)
+else (FREEBSD OR DRAGONFLY)
 SET (TIMEW_MAN1DIR share/man/man1 CACHE STRING "Installation directory for man pages, section 1")
 SET (TIMEW_MAN5DIR share/man/man5 CACHE STRING "Installation directory for man pages, section 5")
-endif (FREEBSD)
+endif (FREEBSD OR DRAGONFLY)
 SET (TIMEW_DOCDIR  share/doc/timew CACHE STRING "Installation directory for doc files")
 
 message ("-- Configuring cmake.h")

=== debian/changelog ===
timew (1.1.0+ds.1-1) unstable; urgency=medium

  * New upstream version: 1.1.0
  * Update Standards-Version to 4.1.3 (no changes)
  * Update debhelper compat to 11
  * Retire reproducible.patch in favour of SOURCE_DATE_EPOCH
  * Refresh doc-install.patch
  * Update VCS URLs to salsa.d.o

 -- Gordon Ball <gordon@chronitis.net>  Mon, 05 Feb 2018 18:38:24 +0000

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Debian Tasktools Packaging Team <taskdeb-discuss@nongnu.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
-Build-Depends: debhelper (>= 10), cmake, git, python
-Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 11~), cmake, git, python
+Standards-Version: 4.1.3
 Homepage: https://taskwarrior.org/
-Vcs-Browser: https://anonscm.debian.org/git/pkg-tasktools/timew.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-tasktools/timew.git
+Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
+Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git
 
 Package: timewarrior
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	dh_auto_configure
 
 override_dh_installchangelogs:
-	dh_installchangelogs ChangeLog
+	dh_installchangelogs -k ChangeLog
 
 get-orig-source:
 	@echo downloading git tag v$(TAG_VERSION)

## timew 1.1.1+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.1.0")
+set (PROJECT_VERSION "1.1.1")
 
 message ("-- Looking for SHA1 references")
 if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,6 @@
                     libshared/src/Duration.cpp      libshared/src/Duration.h
                     libshared/src/FS.cpp            libshared/src/FS.h
                     libshared/src/JSON.cpp          libshared/src/JSON.h
-                    libshared/src/JSON2.cpp         libshared/src/JSON2.h
                     libshared/src/Lexer.cpp         libshared/src/Lexer.h
                     libshared/src/Msg.cpp           libshared/src/Msg.h
                     libshared/src/Palette.cpp       libshared/src/Palette.h

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
                    CmdLengthen.cpp
                    CmdMove.cpp
                    CmdReport.cpp
+                   CmdResize.cpp
                    CmdStart.cpp
                    CmdStop.cpp
                    CmdSummary.cpp

=== src/libshared/src/CMakeLists.txt ===
--- 
+++ 
@@ -10,15 +10,17 @@
                     Duration.h
                     FS.h
                     JSON.h
-                    JSON2.h
                     Lexer.h
                     Log.h
                     Msg.h
+                    Packrat.h
                     Palette.h
+                    PEG.h
                     Pig.h
                     RX.h
                     Table.h
                     Timer.h
+                    Tree.h
                     shared.h
                     format.h
                     unicode.h
@@ -32,17 +34,22 @@
                  Duration.cpp
                  FS.cpp
                  JSON.cpp
-                 JSON2.cpp
                  Lexer.cpp
                  Log.cpp
                  Msg.cpp
+                 Packrat.cpp
                  Palette.cpp
+                 PEG.cpp
                  Pig.cpp
                  RX.cpp
+                 SAX.cpp
                  Table.cpp
                  Timer.cpp
+                 Tree.cpp
+                 ct.cpp
+                 format.cpp
+                 ip.cpp
                  shared.cpp
-                 format.cpp
                  unicode.cpp
                  utf8.cpp
                  wcwidth6.cpp
@@ -53,3 +60,7 @@
 set (CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries")
 install (TARGETS shared DESTINATION lib)
 install (FILES ${shared_HEADERS} DESTINATION include)
+
+add_executable (lex_executable lex.cpp)
+target_link_libraries (lex_executable shared)
+set_property (TARGET lex_executable PROPERTY OUTPUT_NAME "lex")

=== src/libshared/test/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
                      ${CMAKE_SOURCE_DIR}/test
                      ${SHARED_INCLUDE_DIRS})
 
-set (test_SRCS args.t autocomplete.t composite.t color.t shared.t configuration.t datetime.t duration.t format.t fs.t json.t json_test json2_test lexer.t list.t msg.t palette.t pig.t rx.t table.t unicode.t utf8.t)
+set (test_SRCS args.t autocomplete.t charliteral.t composite.t color.t configuration.t ct.t dates.t datetime.t duration.t external.t format.t fs.t intrinsic.t json.t json_test lexer.t list.t msg.t negative.t palette.t peg.t pig.t plus.t positive.t question.t rx.t sax_test shared.t star.t stringliteral.t table.t timer.t tree.t unicode.t utf8.t)
 
 add_custom_target (test ./run_all --verbose
                         DEPENDS ${test_SRCS}

=== debian/changelog ===
timew (1.1.1+ds.1-1) unstable; urgency=medium

  * New upstream version: 1.1.1
  * Update Standards-Version to 4.1.4

 -- Gordon Ball <gordon@chronitis.net>  Sun, 06 May 2018 16:55:39 +0200

timew (1.1.0+ds.1-2) unstable; urgency=medium

  * Patch out tests which calculate relative times but wrap in the early
    morning, which can cause rebuild or CI failures.

 -- Gordon Ball <gordon@chronitis.net>  Wed, 28 Feb 2018 19:37:18 +0000

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Tasktools Packaging Team <taskdeb-discuss@nongnu.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper (>= 11~), cmake, git, python
-Standards-Version: 4.1.3
-Homepage: https://taskwarrior.org/
+Standards-Version: 4.1.4
+Homepage: https://timewarrior.net/
 Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
 Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
TAG_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | tr '~' '.' | sed -e 's/+[dfsg]\+.*//')

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	find . -type f -exec sed -i '1s|^#!/usr/bin/env python|#!/usr/bin/python|' {} \;
	dh_auto_configure

override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

get-orig-source:
	@echo downloading git tag v$(TAG_VERSION)
	git clone -b v$(TAG_VERSION) --depth 1 --recursive https://github.com/GothenburgBitFactory/timewarrior.git
	tar -cJ --wildcards --owner=root --group=root --mode=a+rX --exclude '.git*' -f timew_$(DEB_VERSION_UPSTREAM).orig.tar.xz timewarrior/
	rm -rf timewarrior/

=== debian/tests/control ===
Tests: timewarrior
Depends: @, python

## timew 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.1.1")
+set (PROJECT_VERSION "1.2.0")
 
 message ("-- Looking for SHA1 references")
 if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
@@ -21,18 +21,21 @@
 
 set (PACKAGE "${PROJECT_NAME}")
 set (VERSION "${PROJECT_VERSION}")
-set (PACKAGE_BUGREPORT "support@taskwarrior.org")
+set (PACKAGE_BUGREPORT "support@gothenburgbitfactory.org")
 set (PACKAGE_NAME "${PACKAGE}")
 set (PACKAGE_TARNAME "${PACKAGE}")
 set (PACKAGE_VERSION "${VERSION}")
 set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
+string (TIMESTAMP PACKAGE_DATE "%Y-%m-%d")
 
 if (FREEBSD OR DRAGONFLY)
 SET (TIMEW_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
 SET (TIMEW_MAN5DIR man/man5 CACHE STRING "Installation directory for man pages, section 5")
+SET (TIMEW_MAN7DIR man/man7 CACHE STRING "Installation directory for man pages, section 7")
 else (FREEBSD OR DRAGONFLY)
 SET (TIMEW_MAN1DIR share/man/man1 CACHE STRING "Installation directory for man pages, section 1")
 SET (TIMEW_MAN5DIR share/man/man5 CACHE STRING "Installation directory for man pages, section 5")
+SET (TIMEW_MAN7DIR share/man/man7 CACHE STRING "Installation directory for man pages, section 7")
 endif (FREEBSD OR DRAGONFLY)
 SET (TIMEW_DOCDIR  share/doc/timew CACHE STRING "Installation directory for doc files")

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring documentation")

add_subdirectory (holidays)
add_subdirectory (themes)

configure_file (man1/timew.1.in man1/timew.1)
configure_file (man1/timew-annotate.1.in man1/timew-annotate.1)
configure_file (man1/timew-cancel.1.in man1/timew-cancel.1)
configure_file (man1/timew-chart.1.in man1/timew-chart.1)
configure_file (man1/timew-config.1.in man1/timew-config.1)
configure_file (man1/timew-continue.1.in man1/timew-continue.1)
configure_file (man1/timew-day.1.in man1/timew-day.1)
configure_file (man1/timew-delete.1.in man1/timew-delete.1)
configure_file (man1/timew-diagnostics.1.in man1/timew-diagnostics.1)
configure_file (man1/timew-export.1.in man1/timew-export.1)
configure_file (man1/timew-extensions.1.in man1/timew-extensions.1)
configure_file (man1/timew-fill.1.in man1/timew-fill.1)
configure_file (man1/timew-gaps.1.in man1/timew-gaps.1)
configure_file (man1/timew-get.1.in man1/timew-get.1)
configure_file (man1/timew-help.1.in man1/timew-help.1)
configure_file (man1/timew-join.1.in man1/timew-join.1)
configure_file (man1/timew-lengthen.1.in man1/timew-lengthen.1)
configure_file (man1/timew-modify.1.in man1/timew-modify.1)
configure_file (man1/timew-month.1.in man1/timew-month.1)
configure_file (man1/timew-move.1.in man1/timew-move.1)
configure_file (man1/timew-report.1.in man1/timew-report.1)
configure_file (man1/timew-resize.1.in man1/timew-resize.1)
configure_file (man1/timew-shorten.1.in man1/timew-shorten.1)
configure_file (man1/timew-show.1.in man1/timew-show.1)
configure_file (man1/timew-split.1.in man1/timew-split.1)
configure_file (man1/timew-start.1.in man1/timew-start.1)
configure_file (man1/timew-stop.1.in man1/timew-stop.1)
configure_file (man1/timew-summary.1.in man1/timew-summary.1)
configure_file (man1/timew-tag.1.in man1/timew-tag.1)
configure_file (man1/timew-tags.1.in man1/timew-tags.1)
configure_file (man1/timew-track.1.in man1/timew-track.1)
configure_file (man1/timew-undo.1.in man1/timew-undo.1)
configure_file (man1/timew-untag.1.in man1/timew-untag.1)
configure_file (man1/timew-week.1.in man1/timew-week.1)

configure_file (man1/timew-config.7.in man1/timew-config.7)
configure_file (man1/timew-dates.7.in man1/timew-dates.7)
configure_file (man1/timew-dom.7.in man1/timew-dom.7)
configure_file (man1/timew-durations.7.in man1/timew-durations.7)
configure_file (man1/timew-hints.7.in man1/timew-hints.7)
configure_file (man1/timew-ranges.7.in man1/timew-ranges.7)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1/ DESTINATION ${TIMEW_MAN1DIR} FILES_MATCHING PATTERN "*.1")
install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1/ DESTINATION ${TIMEW_MAN7DIR} FILES_MATCHING PATTERN "*.7")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,22 @@
                      ${TIMEW_INCLUDE_DIRS})
 
 set (timew_SRCS CLI.cpp        CLI.h
+                Chart.cpp      Chart.h
+                               ChartConfig.h
                 Database.cpp   Database.h
                 Datafile.cpp   Datafile.h
                 Exclusion.cpp  Exclusion.h
                 Extensions.cpp Extensions.h
                 Interval.cpp   Interval.h
+                IntervalFactory.cpp IntervalFactory.h
+                Journal.cpp    Journal.h
                 Range.cpp      Range.h
                 Rules.cpp      Rules.h
+                TagInfo.cpp    TagInfo.h
+                TagInfoDatabase.cpp TagInfoDatabase.h
+                Transaction.cpp Transaction.h
+                TransactionsFactory.cpp TransactionsFactory.h
+                UndoAction.cpp UndoAction.h
                 data.cpp
                 dom.cpp
                 init.cpp

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
 cmake_minimum_required (VERSION 2.8)
 
-# See this CMake issue before complaining about the following.
-# https://cmake.org/Bug/view.php?id=16062
-if(POLICY CMP0037)
+# This is a work-around for the following CMake issue:
+# https://gitlab.kitware.com/cmake/cmake/issues/16062
+# The issue has been fixed in CMake 3.11.0; the policy is set
+# to OLD for compatibility with older versions of CMake only.
+if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
   cmake_policy(SET CMP0037 OLD)
 endif()
 
@@ -14,7 +16,7 @@
 include_directories (${CMAKE_INSTALL_PREFIX}/include)
 link_directories(${CMAKE_INSTALL_PREFIX}/lib)
 
-set (test_SRCS data.t exclusion.t helper.t interval.t range.t rules.t util.t)
+set (test_SRCS data.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)
 
 add_custom_target (test ./run_all --verbose
                         DEPENDS ${test_SRCS}

=== doc/themes/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring theme documentation")

install (FILES README           DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark.theme       DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_blue.theme  DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_green.theme DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_red.theme   DESTINATION ${TIMEW_DOCDIR}/doc/themes)

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,8 @@
                      ${CMAKE_SOURCE_DIR}/src/libshared/src
                      ${TIMEW_INCLUDE_DIRS})
 
-set (commands_SRCS CmdCancel.cpp
+set (commands_SRCS CmdAnnotate.cpp
+                   CmdCancel.cpp
                    CmdChart.cpp
                    CmdConfig.cpp
                    CmdContinue.cpp
@@ -20,6 +21,7 @@
                    CmdHelp.cpp
                    CmdJoin.cpp
                    CmdLengthen.cpp
+                   CmdModify.cpp
                    CmdMove.cpp
                    CmdReport.cpp
                    CmdResize.cpp
@@ -32,6 +34,7 @@
                    CmdTag.cpp
                    CmdTags.cpp
                    CmdTrack.cpp
+                   CmdUndo.cpp
                    CmdUntag.cpp)
 
 add_library (commands STATIC ${commands_SRCS})

=== debian/changelog ===
timew (1.2.0-1) unstable; urgency=medium

  * New upstream version 1.2.0
  * Debhelper compat 12, drop d/compat file
  * Standards-Version 4.4.1
  * Update source URL in d/copyright
  * Refresh patches
  * Install upstream bash completion (Closes: #850046)
  * Declare that root is not required for build

 -- Gordon Ball <gordon@chronitis.net>  Tue, 26 Nov 2019 19:31:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Debian Tasktools Packaging Team <taskdeb-discuss@nongnu.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
-Build-Depends: debhelper (>= 11~), cmake, git, python
-Standards-Version: 4.1.4
+Build-Depends: debhelper-compat (= 12), cmake, git, python
+Standards-Version: 4.4.1
 Homepage: https://timewarrior.net/
 Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
 Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git
+Rules-Requires-Root: no
 
 Package: timewarrior
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,11 @@
 	find . -type f -exec sed -i '1s|^#!/usr/bin/env python|#!/usr/bin/python|' {} \;
 	dh_auto_configure
 
+override_dh_auto_install:
+	dh_auto_install
+	mkdir -p debian/timewarrior/usr/share/bash-completion
+	cp completion/timew-completion.bash debian/timewarrior/usr/share/bash-completion/timew
+
 override_dh_installchangelogs:
 	dh_installchangelogs -k ChangeLog

=== debian/tests/control ===
Tests: timewarrior
Depends: @, python, python-dateutil, man-db

## timew 1.3.0+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,9 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.2.0")
+set (PROJECT_VERSION "1.3.0")
+
+string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
 
 message ("-- Looking for SHA1 references")
 if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,8 @@
                      ${CMAKE_SOURCE_DIR}/src/libshared/src
                      ${TIMEW_INCLUDE_DIRS})
 
-set (timew_SRCS CLI.cpp        CLI.h
+set (timew_SRCS AtomicFile.cpp AtomicFile.h
+                CLI.cpp        CLI.h
                 Chart.cpp      Chart.h
                                ChartConfig.h
                 Database.cpp   Database.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,24 @@
   cmake_policy(SET CMP0037 OLD)
 endif()
 
+# If this is a debug build, check if we have libfiu installed and available on
+# the system. If so, we will be able to use it to add additional tests of the
+# failure conditions
+
+if (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
+  find_library(FIU_ENABLE fiu) 
+  if (FIU_ENABLE)
+    message (STATUS "libfiu found")
+    add_definitions (-DFIU_ENABLE)
+    set (test_LIBS fiu ${TIMEW_LIBRARIES})
+  else (FIU_ENABLE)
+    message (STATUS "NOTE: install libfiu to run additional tests")
+    set (test_LIBS ${TIMEW_LIBRARIES})
+  endif (FIU_ENABLE)
+else (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
+  set (test_LIBS ${TIMEW_LIBRARIES})
+endif (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
+
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src
                      ${CMAKE_SOURCE_DIR}/src/libshared/src
@@ -16,7 +34,7 @@
 include_directories (${CMAKE_INSTALL_PREFIX}/include)
 link_directories(${CMAKE_INSTALL_PREFIX}/lib)
 
-set (test_SRCS data.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)
+set (test_SRCS AtomicFileTest data.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)
 
 add_custom_target (test ./run_all --verbose
                         DEPENDS ${test_SRCS}
@@ -24,9 +42,8 @@
 
 foreach (src_FILE ${test_SRCS})
   add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
-  target_link_libraries (${src_FILE} timew libshared ${TIMEW_LIBRARIES})
+  target_link_libraries (${src_FILE} timew libshared ${test_LIBS})
 endforeach (src_FILE)
 
 configure_file(run_all run_all COPYONLY)
 configure_file(problems problems COPYONLY)
-

=== debian/changelog ===
timew (1.3.0+ds.1-1) unstable; urgency=medium

  * New upstream version 1.3.0+ds.1
    + The previous version _should_ have been 1.2.0+ds.1, but the +ds
      suffix was accidentally omitted; the source is repacked since upstream
      uses submodules and includes some prebuilt documentation in tarballs
  * Refresh patches
    + Drop d/p/drop-completion-shebang.patch, applied upstream
    + Drop d/p/backport-python3.patch, backport from this version
  * Skip tests requiring compilation or not working with the installed package
    in autopkgtest

 -- Gordon Ball <gordon@chronitis.net>  Fri, 24 Apr 2020 19:15:57 +0000

timew (1.2.0-2) unstable; urgency=medium

  * Install bash-completion script in the correct location; patch from
    Clément Hermann. (Closes: #951546)
  * Patch out unneeded shebang line from bash-completion script.
  * Update to Standards-Version 4.5.0
  * Backport python3 compatibility changes from upstream; all tests and
    scripts now require python3 rather than python2. (Closes: #943288)

 -- Gordon Ball <gordon@chronitis.net>  Fri, 06 Mar 2020 19:19:13 +0000

## timew 1.4.2+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 project (timew)
 include (CXXSniffer)
 
-set (PROJECT_VERSION "1.3.0")
+set (PROJECT_VERSION "1.4.2")
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
 
@@ -54,7 +54,7 @@
   add_subdirectory (test EXCLUDE_FROM_ALL)
 endif (EXISTS ${CMAKE_SOURCE_DIR}/test)
 
-set (doc_FILES NEWS ChangeLog README.md INSTALL AUTHORS COPYING LICENSE)
+set (doc_FILES ChangeLog README.md INSTALL AUTHORS LICENSE)
 foreach (doc_FILE ${doc_FILES})
   install (FILES ${doc_FILE}  DESTINATION ${TIMEW_DOCDIR})
 endforeach (doc_FILE)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -40,12 +40,12 @@
 configure_file (man1/timew-untag.1.in man1/timew-untag.1)
 configure_file (man1/timew-week.1.in man1/timew-week.1)
 
-configure_file (man1/timew-config.7.in man1/timew-config.7)
-configure_file (man1/timew-dates.7.in man1/timew-dates.7)
-configure_file (man1/timew-dom.7.in man1/timew-dom.7)
-configure_file (man1/timew-durations.7.in man1/timew-durations.7)
-configure_file (man1/timew-hints.7.in man1/timew-hints.7)
-configure_file (man1/timew-ranges.7.in man1/timew-ranges.7)
+configure_file (man7/timew-config.7.in man7/timew-config.7)
+configure_file (man7/timew-dates.7.in man7/timew-dates.7)
+configure_file (man7/timew-dom.7.in man7/timew-dom.7)
+configure_file (man7/timew-durations.7.in man7/timew-durations.7)
+configure_file (man7/timew-hints.7.in man7/timew-hints.7)
+configure_file (man7/timew-ranges.7.in man7/timew-ranges.7)
 
 install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1/ DESTINATION ${TIMEW_MAN1DIR} FILES_MATCHING PATTERN "*.1")
-install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1/ DESTINATION ${TIMEW_MAN7DIR} FILES_MATCHING PATTERN "*.7")
+install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man7/ DESTINATION ${TIMEW_MAN7DIR} FILES_MATCHING PATTERN "*.7")

=== ext/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

message ("-- Configuring extensions")

install (FILES on-modify.timewarrior totals.py DESTINATION ${TIMEW_DOCDIR}/ext)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
                                ChartConfig.h
                 Database.cpp   Database.h
                 Datafile.cpp   Datafile.h
+                DatetimeParser.cpp DatetimeParser.h
                 Exclusion.cpp  Exclusion.h
                 Extensions.cpp Extensions.h
                 Interval.cpp   Interval.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -34,10 +34,10 @@
 include_directories (${CMAKE_INSTALL_PREFIX}/include)
 link_directories(${CMAKE_INSTALL_PREFIX}/lib)
 
-set (test_SRCS AtomicFileTest data.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)
+set (test_SRCS AtomicFileTest data.t Datafile.t DatetimeParser.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)
 
 add_custom_target (test ./run_all --verbose
-                        DEPENDS ${test_SRCS}
+                        DEPENDS ${test_SRCS} timew_executable
                         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)
 
 foreach (src_FILE ${test_SRCS})

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,18 @@
                      ${CMAKE_SOURCE_DIR}/src/commands
                      ${CMAKE_SOURCE_DIR}/src/libshared/src
                      ${TIMEW_INCLUDE_DIRS})
+
+set (ADDITIONAL_HELP_H "additional-help.h")
+
+ADD_CUSTOM_COMMAND (
+	OUTPUT ${ADDITIONAL_HELP_H}
+	COMMAND /bin/sh src/commands/generate-additional-help.sh > src/commands/${ADDITIONAL_HELP_H}
+	DEPENDS ${CMAKE_CURRENT_LIST_DIR}/generate-additional-help.sh
+	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+	COMMENT "Generating ${ADDITIONAL_HELP_H}")
+
+ADD_CUSTOM_TARGET (generate_additional_help
+									 DEPENDS ${ADDITIONAL_HELP_H})
 
 set (commands_SRCS CmdAnnotate.cpp
                    CmdCancel.cpp
@@ -38,4 +50,4 @@
                    CmdUntag.cpp)
 
 add_library (commands STATIC ${commands_SRCS})
-
+add_dependencies (commands generate_additional_help)

=== debian/changelog ===
timew (1.4.2+ds.1-3ubuntu1) hirsute; urgency=medium

  * debian/patches/0001-Fix-test-summary.t-for-single-digit-weeks.patch
    Apply upstream commit 1a6c30b93ae04406be6be4cb4f619b30f221fd7b to fix
    test in single-digit weeks. More work is needed for mixed single-double
    digit weeks: https://github.com/GothenburgBitFactory/timewarrior/issues/409

 -- Lukas Märdian <lukas.maerdian@canonical.com>  Fri, 29 Jan 2021 09:32:24 +0100

timew (1.4.2+ds.1-3) unstable; urgency=medium

  * Update team email address to Debian Tasktools Team
    <team+tasktools@tracker.debian.org>
  * Patch out tests which fail when the week number is a single digit

 -- Gordon Ball <gordon@chronitis.net>  Sun, 10 Jan 2021 19:08:40 +0000

timew (1.4.2+ds.1-2) unstable; urgency=medium

  * Patch testsuite errors with Python 3.9 (Closes: #975516)

 -- Gordon Ball <gordon@chronitis.net>  Mon, 23 Nov 2020 16:33:32 +0000

timew (1.4.2+ds.1-1) unstable; urgency=medium

  * New upstream version 1.4.2+ds.1
  * Refresh patches

 -- Gordon Ball <gordon@chronitis.net>  Mon, 31 Aug 2020 15:16:33 +0000

=== debian/control ===
Source: timew
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Tasktools Team <team+tasktools@tracker.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 12), cmake, git, python3, bash-completion
Standards-Version: 4.5.0
Homepage: https://timewarrior.net/
Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git
Rules-Requires-Root: no

Package: timewarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: python3
Recommends: taskwarrior
Description: feature-rich time tracking utility
 Timewarrior is a time tracking utility that offers simple stopwatch features
 as well as sophisticated calendar-based backfill, along with flexible
 reporting.
